Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/ClientNodeView.Designer.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/ClientNodeView.Designer.cs	(revision 11465)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks.Views/3.3/ClientNodeView.Designer.cs	(revision 11468)
@@ -48,11 +48,12 @@
       this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
       this.portsTabPage = new System.Windows.Forms.TabPage();
-      this.callsTabPage = new System.Windows.Forms.TabPage();
+      this.serviceCallsTabPage = new System.Windows.Forms.TabPage();
       this.serviceParameterCollectionCollectionView = new HeuristicLab.Optimization.Networks.Views.ServiceParameterCollectionCollectionView();
-      this.callButton = new System.Windows.Forms.Button();
+      this.callServicesButton = new System.Windows.Forms.Button();
+      this.cancelServicesButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl.SuspendLayout();
       this.portsTabPage.SuspendLayout();
-      this.callsTabPage.SuspendLayout();
+      this.serviceCallsTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -83,10 +84,10 @@
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tabControl.Controls.Add(this.portsTabPage);
-      this.tabControl.Controls.Add(this.callsTabPage);
+      this.tabControl.Controls.Add(this.serviceCallsTabPage);
       this.tabControl.Location = new System.Drawing.Point(0, 63);
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
       this.tabControl.Size = new System.Drawing.Size(645, 454);
-      this.tabControl.TabIndex = 4;
+      this.tabControl.TabIndex = 5;
       // 
       // portsTabPage
@@ -101,13 +102,13 @@
       this.portsTabPage.UseVisualStyleBackColor = true;
       // 
-      // callsTabPage
+      // serviceCallsTabPage
       // 
-      this.callsTabPage.Controls.Add(this.serviceParameterCollectionCollectionView);
-      this.callsTabPage.Location = new System.Drawing.Point(4, 22);
-      this.callsTabPage.Name = "callsTabPage";
-      this.callsTabPage.Size = new System.Drawing.Size(637, 428);
-      this.callsTabPage.TabIndex = 2;
-      this.callsTabPage.Text = "Calls";
-      this.callsTabPage.UseVisualStyleBackColor = true;
+      this.serviceCallsTabPage.Controls.Add(this.serviceParameterCollectionCollectionView);
+      this.serviceCallsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.serviceCallsTabPage.Name = "serviceCallsTabPage";
+      this.serviceCallsTabPage.Size = new System.Drawing.Size(637, 428);
+      this.serviceCallsTabPage.TabIndex = 2;
+      this.serviceCallsTabPage.Text = "Service Calls";
+      this.serviceCallsTabPage.UseVisualStyleBackColor = true;
       // 
       // serviceParameterCollectionCollectionView
@@ -125,20 +126,29 @@
       this.serviceParameterCollectionCollectionView.TabIndex = 0;
       // 
-      // callButton
+      // callServicesButton
       // 
-      this.callButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.callButton.Location = new System.Drawing.Point(69, 26);
-      this.callButton.Name = "callButton";
-      this.callButton.Size = new System.Drawing.Size(551, 23);
-      this.callButton.TabIndex = 3;
-      this.callButton.Text = "&Call Services";
-      this.callButton.UseVisualStyleBackColor = true;
-      this.callButton.Click += new System.EventHandler(this.callButton_Click);
+      this.callServicesButton.Location = new System.Drawing.Point(69, 26);
+      this.callServicesButton.Name = "callServicesButton";
+      this.callServicesButton.Size = new System.Drawing.Size(101, 23);
+      this.callServicesButton.TabIndex = 3;
+      this.callServicesButton.Text = "&Call Services";
+      this.callServicesButton.UseVisualStyleBackColor = true;
+      this.callServicesButton.Click += new System.EventHandler(this.callServicesButton_Click);
+      // 
+      // cancelServicesButton
+      // 
+      this.cancelServicesButton.Location = new System.Drawing.Point(176, 26);
+      this.cancelServicesButton.Name = "cancelServicesButton";
+      this.cancelServicesButton.Size = new System.Drawing.Size(101, 23);
+      this.cancelServicesButton.TabIndex = 4;
+      this.cancelServicesButton.Text = "&Cancel Services";
+      this.cancelServicesButton.UseVisualStyleBackColor = true;
+      this.cancelServicesButton.Click += new System.EventHandler(this.cancelServicesButton_Click);
       // 
       // ClientNodeView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.callButton);
+      this.Controls.Add(this.cancelServicesButton);
+      this.Controls.Add(this.callServicesButton);
       this.Controls.Add(this.tabControl);
       this.Name = "ClientNodeView";
@@ -147,9 +157,10 @@
       this.Controls.SetChildIndex(this.infoLabel, 0);
       this.Controls.SetChildIndex(this.tabControl, 0);
-      this.Controls.SetChildIndex(this.callButton, 0);
+      this.Controls.SetChildIndex(this.callServicesButton, 0);
+      this.Controls.SetChildIndex(this.cancelServicesButton, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.tabControl.ResumeLayout(false);
       this.portsTabPage.ResumeLayout(false);
-      this.callsTabPage.ResumeLayout(false);
+      this.serviceCallsTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -162,7 +173,8 @@
     protected System.Windows.Forms.TabPage portsTabPage;
     protected HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
-    protected System.Windows.Forms.TabPage callsTabPage;
+    protected System.Windows.Forms.TabPage serviceCallsTabPage;
     protected ServiceParameterCollectionCollectionView serviceParameterCollectionCollectionView;
-    protected System.Windows.Forms.Button callButton;
+    protected System.Windows.Forms.Button callServicesButton;
+    protected System.Windows.Forms.Button cancelServicesButton;
 
 